﻿/*
# #############################################################################
#  ATTENTION
# #############################################################################
#
#  This software is for guidance only. It is provided "as is".
#  It only aims at providing coding information to the customer in order for
#  them to save time. As a result no warranties, whether express, implied or
#  statutory, including, but not limited to implied warranties of
#  merchantability and fitness for a particular purpose apply to this software.
#  A·P·E Angewandte Physik und Elektronik GmbH shall not be held liable for any
#  direct, indirect or consequential damages with respect to any claims arising
#  from the content of such sourcecode and/or the use made by customers of the
#  coding information contained herein in connection with their products.
#
#  File Version: 1.0
#
#  Changelog:
#    1.0 - Initial Version
#
# #############################################################################
*/

using System;
using System.IO;
using System.Text;
using System.Collections.Generic;
using System.Globalization;

namespace APE_Interface_Example
{
    public class APE_Interface_Example
    {
        public static int Main(String[] args)
        {
            //By default C# uses the "," as decimal separator in some countries (aspecially inside the EU)
            //To fix this, the following three commands set the "." as decimal separator for the application.
            System.Globalization.CultureInfo customCulture = (System.Globalization.CultureInfo)System.Threading.Thread.CurrentThread.CurrentCulture.Clone();
            customCulture.NumberFormat.NumberDecimalSeparator = ".";
            System.Threading.Thread.CurrentThread.CurrentCulture = customCulture;

            //Create new APE_Device Object.
            //Class Constructor will automatically try to connect to the given remote target
            APE_Device device = new APE_Device("localhost", 51123, "APEDevice");
            if (!device.is_connected())
            {
                Console.WriteLine("Connection failed.");
                Console.ReadKey();
                return 1;
            }

            Console.WriteLine("Connected.\n");

            //Get Device IDN
            Console.WriteLine("SCPI Device IDN: ");
            Console.WriteLine(device.query("*IDN?\r\n"));
            
            //Close TCP Socket connection to the device, since we won't send or receive any more data
            device.disconnect();
           
            Console.WriteLine("\nPlease press RETURN to continue...");
            Console.ReadKey();
            return 0;
        }
    }
}